diff --git a/.ci/Jenkinsfile b/.ci/Jenkinsfile
index 52b618c221019a32a99da23e66963cd076c1ac7b..1e5a9079acfd957c2210543b548ea6864976fcac 100755
--- a/.ci/Jenkinsfile
+++ b/.ci/Jenkinsfile
@@ -60,77 +60,80 @@ pipeline {
 				}
 				stage('yashchiki Checkout') {
 					steps {
-						checkout scm
+						script {
+							sh "git clone ssh://hudson@brainscales-r.kip.uni-heidelberg.de:29418/waf.git symwaf2ic"
+							sh "cd symwaf2ic && singularity exec /containers/stable/latest make"
+							if (!env.GERRIT_CHANGE_NUMBER) {
+								sh "singularity exec /containers/stable/latest ./symwaf2ic/waf setup --project=yashchiki --clone-depth=2"
+							} else {
+								sh "singularity exec /containers/stable/latest ./symwaf2ic/waf setup --project=yashchiki --clone-depth=2 --gerrit-changes=${GERRIT_CHANGE_NUMBER} --gerrit-url=ssh://hudson@${GERRIT_HOST}:${GERRIT_PORT}"
+							}
+						}
 					}
 				}
 				stage('Validate environment') {
 					steps {
-						sh ".ci/validate_environment.sh"
-					}
-				}
-				stage('Spack Clone') {
-					steps {
-						sh ".ci/clone.sh"
+						sh "yashchiki/.ci/validate_environment.sh"
 					}
 				}
 				stage('Dump Meta Info') {
 					steps {
-						sh ".ci/dump_meta_info.sh"
-						sh ".ci/notify_gerrit.sh -m 'Build containing this change started..'"
+						sh "yashchiki/.ci/dump_meta_info.sh"
+						sh "yashchiki/.ci/notify_gerrit.sh -m 'Build containing this change started..'"
 					}
 				}
 				stage('Spack Fetch') {
 					steps {
 						script {
 							try {
-								sh ".ci/fetch.sh"
+								sh "yashchiki/.ci/fetch.sh"
 							}
 							catch (Throwable t) {
 								archiveArtifacts "errors_concretization.log"
 								throw t
 							}
-							spec_folder_in_container = sh(script: ".ci/get_jenkins_env.sh SPEC_FOLDER_IN_CONTAINER", returnStdout: true).trim()
+							spec_folder_in_container = sh(script: "yashchiki/.ci/get_jenkins_env.sh SPEC_FOLDER_IN_CONTAINER", returnStdout: true).trim()
 							archiveArtifacts(artifacts: "sandboxes/*/$spec_folder_in_container/*.yaml", allowEmptyArchive: true)
 						}
 					}
 				}
 				stage('Deploy utilities') {
 					steps {
-						sh ".ci/deploy_utilities.sh"
+						sh "yashchiki/.ci/deploy_utilities.sh"
 					}
 				}
 				stage('Create visionary recipe') {
 					steps {
-						sh ".ci/visionary_create_recipe.sh"
+						sh "yashchiki/.ci/visionary_create_recipe.sh"
 					}
 				}
 				stage('Build sandbox') {
 					steps {
-						sh ".ci/build_sandbox.sh"
+						sh "yashchiki/.ci/build_sandbox.sh"
 					}
 				}
 				stage('Build container image') {
 					steps {
-						sh ".ci/build_image.sh"
+						sh "yashchiki/.ci/build_image.sh"
 					}
 				}
 				stage('Update build cache and export container') {
 					steps {
 						script {
 							// we only want the container name, tail everything else
-							CONTAINER_IMAGE = sh(script: ".ci/deploy_container.sh | tail -n 1", returnStdout: true).trim()
+							CONTAINER_IMAGE = sh(script: "yashchiki/.ci/deploy_container.sh | tail -n 1", returnStdout: true).trim()
 						}
-						sh ".ci/update_build_cache.sh -c \"$CONTAINER_IMAGE\""
-						sh ".ci/notify_gerrit.sh -t Build -c \"$CONTAINER_IMAGE\""
+						sh "yashchiki/.ci/update_build_cache.sh -c \"$CONTAINER_IMAGE\""
+						sh "yashchiki/.ci/notify_gerrit.sh -t Build -c \"$CONTAINER_IMAGE\""
 					}
 				}
 			}
 			post {
 				failure {
 					script {
-						cache_failed = sh(script: ".ci/create_temporary_build_cache_after_failure.sh", returnStdout: true).trim()
+						cache_failed = sh(script: "yashchiki/.ci/create_temporary_build_cache_after_failure.sh", returnStdout: true).trim()
 					}
-					sh ".ci/notify_gerrit.sh -v -1 -t Build -m \"Successfully built packages stored in cache. Resume by issuing:\nWITH_CACHE_NAME=${cache_failed}\n\nIn your next gerrit comment, NOT commit message!\""
+					sh "yashchiki/.ci/notify_gerrit.sh -v -1 -t Build -m \"Successfully built packages stored in cache. Resume by issuing:\nWITH_CACHE_NAME=${cache_failed}\n\nIn your next gerrit comment, NOT commit message!\""
 				}
 				cleanup {
 					archiveArtifacts "jenkins.env"
diff --git a/.ci/Jenkinsfile_asic b/.ci/Jenkinsfile_asic
index eafcd599c5dfa2cb6a3da717d9b99c04665f1970..67bdaa18c18efd5dd474eb09222bb928374fbd6d 100755
--- a/.ci/Jenkinsfile_asic
+++ b/.ci/Jenkinsfile_asic
@@ -57,77 +57,80 @@ pipeline {
 				}
 				stage('yashchiki Checkout') {
 					steps {
-						checkout scm
+						script {
+							sh "git clone ssh://hudson@brainscales-r.kip.uni-heidelberg.de:29418/waf.git symwaf2ic"
+							sh "cd symwaf2ic && singularity exec /containers/stable/latest make"
+							if (!env.GERRIT_CHANGE_NUMBER) {
+								sh "singularity exec /containers/stable/latest ./symwaf2ic/waf setup --project=yashchiki --clone-depth=2"
+							} else {
+								sh "singularity exec /containers/stable/latest ./symwaf2ic/waf setup --project=yashchiki --clone-depth=2 --gerrit-changes=${GERRIT_CHANGE_NUMBER} --gerrit-url=ssh://hudson@${GERRIT_HOST}:${GERRIT_PORT}"
+							}
+						}
 					}
 				}
 				stage('Validate environment') {
 					steps {
-						sh ".ci/validate_environment.sh"
-					}
-				}
-				stage('Spack Clone') {
-					steps {
-						sh ".ci/clone.sh"
+						sh "yashchiki/.ci/validate_environment.sh"
 					}
 				}
 				stage('Dump Meta Info') {
 					steps {
-						sh ".ci/dump_meta_info.sh"
-						sh ".ci/notify_gerrit.sh -m 'Build containing this change started..'"
+						sh "yashchiki/.ci/dump_meta_info.sh"
+						sh "yashchiki/.ci/notify_gerrit.sh -m 'Build containing this change started..'"
 					}
 				}
 				stage('Spack Fetch') {
 					steps {
 						script {
 							try {
-								sh ".ci/fetch.sh"
+								sh "yashchiki/.ci/fetch.sh"
 							}
 							catch (Throwable t) {
 								archiveArtifacts "errors_concretization.log"
 								throw t
 							}
-							spec_folder_in_container = sh(script: ".ci/get_jenkins_env.sh SPEC_FOLDER_IN_CONTAINER", returnStdout: true).trim()
+							spec_folder_in_container = sh(script: "yashchiki/.ci/get_jenkins_env.sh SPEC_FOLDER_IN_CONTAINER", returnStdout: true).trim()
 							archiveArtifacts(artifacts: "sandboxes/*/$spec_folder_in_container/*.yaml", allowEmptyArchive: true)
 						}
 					}
 				}
 				stage('Deploy utilities') {
 					steps {
-						sh ".ci/deploy_utilities.sh"
+						sh "yashchiki/.ci/deploy_utilities.sh"
 					}
 				}
 				stage('Create asic recipe') {
 					steps {
-						sh ".ci/asic_create_recipe.sh"
+						sh "yashchiki/.ci/asic_create_recipe.sh"
 					}
 				}
 				stage('Build sandbox') {
 					steps {
-						sh ".ci/build_sandbox.sh"
+						sh "yashchiki/.ci/build_sandbox.sh"
 					}
 				}
 				stage('Build container image') {
 					steps {
-						sh ".ci/build_image.sh"
+						sh "yashchiki/.ci/build_image.sh"
 					}
 				}
 				stage('Update build cache and export container') {
 					steps {
 						script {
 							// we only want the container name, tail everything else
-							CONTAINER_IMAGE = sh(script: ".ci/deploy_container.sh | tail -n 1", returnStdout: true).trim()
+							CONTAINER_IMAGE = sh(script: "yashchiki/.ci/deploy_container.sh | tail -n 1", returnStdout: true).trim()
 						}
-						sh ".ci/update_build_cache.sh -c \"$CONTAINER_IMAGE\""
-						sh ".ci/notify_gerrit.sh -t Build -c \"$CONTAINER_IMAGE\""
+						sh "yashchiki/.ci/update_build_cache.sh -c \"$CONTAINER_IMAGE\""
+						sh "yashchiki/.ci/notify_gerrit.sh -t Build -c \"$CONTAINER_IMAGE\""
 					}
 				}
 			}
 			post {
 				failure {
 					script {
-						cache_failed = sh(script: ".ci/create_temporary_build_cache_after_failure.sh", returnStdout: true).trim()
+						cache_failed = sh(script: "yashchiki/.ci/create_temporary_build_cache_after_failure.sh", returnStdout: true).trim()
 					}
-					sh ".ci/notify_gerrit.sh -v -1 -t Build -m \"Successfully built packages stored in cache. Resume by issuing:\nWITH_CACHE_NAME=${cache_failed}\n\nIn your next gerrit comment, NOT commit message!\""
+					sh "yashchiki/.ci/notify_gerrit.sh -v -1 -t Build -m \"Successfully built packages stored in cache. Resume by issuing:\nWITH_CACHE_NAME=${cache_failed}\n\nIn your next gerrit comment, NOT commit message!\""
 				}
 				cleanup {
 					archiveArtifacts "jenkins.env"
diff --git a/.ci/asic_create_recipe.sh b/.ci/asic_create_recipe.sh
index 9cf272c6f8f5e139be4f391519cbb7cde50363a1..8beffecce2b8afdd2c1b0b2b00c1f571326a3f4b 100755
--- a/.ci/asic_create_recipe.sh
+++ b/.ci/asic_create_recipe.sh
@@ -41,7 +41,7 @@ From: ${DOCKER_BASE_IMAGE}
     rsync -av "${META_DIR_OUTSIDE}"/* "\${SINGULARITY_ROOTFS}/${META_DIR_INSIDE}"
     # init scripts for user convenience
     mkdir -p "\${SINGULARITY_ROOTFS}/opt/init"
-    rsync -av "${WORKSPACE}"/misc-files/init/*.sh "\${SINGULARITY_ROOTFS}/opt/init"
+    rsync -av "${WORKSPACE}"/yashchiki/misc-files/init/*.sh "\${SINGULARITY_ROOTFS}/opt/init"
 
 %files
     # NOTE: Due to a bug in singularity 2.6 all paths in this section _cannot_
@@ -49,10 +49,10 @@ From: ${DOCKER_BASE_IMAGE}
     # there are, I pray for your poor soul that escaping them works..
     # --obreitwi, 17-02-19 # 23:45:51
     # provide spack command to login shells
-    ${WORKSPACE}/misc-files/setup-spack.sh /etc/profile.d/setup-spack.sh
-    ${WORKSPACE}/misc-files/locale.gen /etc/locale.gen
-    ${WORKSPACE}/misc-files/locale.alias /etc/locale.alias
-    ${WORKSPACE}/misc-files/sudoers /etc/sudoers
+    ${WORKSPACE}/yashchiki/misc-files/setup-spack.sh /etc/profile.d/setup-spack.sh
+    ${WORKSPACE}/yashchiki/misc-files/locale.gen /etc/locale.gen
+    ${WORKSPACE}/yashchiki/misc-files/locale.alias /etc/locale.alias
+    ${WORKSPACE}/yashchiki/misc-files/sudoers /etc/sudoers
     ${JENKINS_ENV_FILE} ${JENKINS_ENV_FILE_INSIDE}
 
 %post
diff --git a/.ci/clone.sh b/.ci/clone.sh
deleted file mode 100755
index 571d8dbe7137a73eb123db0a2fc2d445523ae84c..0000000000000000000000000000000000000000
--- a/.ci/clone.sh
+++ /dev/null
@@ -1,154 +0,0 @@
-#!/bin/bash
-
-set -euo pipefail
-shopt -s inherit_errexit
-
-SOURCE_DIR="$(dirname "$(readlink -m "${BASH_SOURCE[0]}")")"
-source "${SOURCE_DIR}/commons.sh"
-
-if [ -z "${GERRIT_USERNAME:-}" ]; then
-    GERRIT_USERNAME="hudson"
-fi
-
-if [ -z "${GERRIT_PORT:-}" ]; then
-    GERRIT_PORT=29418
-fi
-
-if [ -z "${GERRIT_HOSTNAME:-}" ]; then
-    GERRIT_HOSTNAME="brainscales-r.kip.uni-heidelberg.de"
-fi
-
-if [ -z "${GERRIT_BASE_URL:-}" ]; then
-    export GERRIT_BASE_URL="ssh://${GERRIT_USERNAME}@${GERRIT_HOSTNAME}:${GERRIT_PORT}"
-fi
-
-# clone spack installation ouside and copy into the container
-MY_GERRIT_URL="${GERRIT_BASE_URL}/spack"
-rm -rf spack
-git clone ${MY_GERRIT_URL} -b visionary spack
-
-# Checkout specific spack change in case we have a testing build.
-#
-# Please note that stable builds should ALWAYS build stable!
-#
-# order of importance:
-# 1. jenkins-specified SPACK_GERRIT_REFSPEC
-# 2. jenkins-specified SPACK_GERRIT_CHANGE
-# 3. triggered gerrit comment contains WITH_SPACK_CHANGE
-# 4. triggered gerrit comment contains WITH_SPACK_REFSPEC
-# 5. commit-specified Depends-On
-#
-# If multiple are specified, take the first variable defined according the
-# order above.
-
-if [ -z "${SPACK_GERRIT_CHANGE:-}" ] && [ -z "${SPACK_GERRIT_REFSPEC:-}" ]; then
-    GERRIT_SPECIFIED_SPACK_CHANGE="$(get_jenkins_env GERRIT_SPECIFIED_SPACK_CHANGE)"
-    GERRIT_SPECIFIED_SPACK_REFSPEC="$(get_jenkins_env GERRIT_SPECIFIED_SPACK_REFSPEC)"
-
-    if [ -n "${GERRIT_SPECIFIED_SPACK_CHANGE}" ]; then
-        SPACK_GERRIT_CHANGE="${GERRIT_SPECIFIED_SPACK_CHANGE}"
-    elif [ -n "${GERRIT_SPECIFIED_SPACK_REFSPEC}" ]; then
-        SPACK_GERRIT_REFSPEC="${GERRIT_SPECIFIED_SPACK_REFSPEC}"
-    else
-        # see if the commit message contains a "Depends-On: xy" line
-        # if there are several lines, concatenate with commas
-        SPACK_GERRIT_CHANGE=$(git log -1 --pretty=%B \
-            | awk '$1 ~ "Depends-On:" { $1 = ""; print $0 }' | tr '\n' ',' | tr -d \[:space:\])
-    fi
-else
-    echo "SPACK_GERRIT_CHANGE or SPACK_GERRIT_REFSPEC specified, ignoring "\
-         "possible 'WITH_SPACK_CHANGE' in gerrit commit message or "\
-         "'Depends-On'-line in commit message!" >&2
-fi
-
-
-# If there is a spack gerrit change specified and no refspec -> resolve!
-if [ -n "${SPACK_GERRIT_CHANGE:-}" ] && [ -z "${SPACK_GERRIT_REFSPEC:-}" ]; then
-    # convert spack change id to latest patchset
-    pushd "spack"
-
-    ref_stable="$(git rev-parse HEAD)"
-
-    gerrit_query=$(mktemp)
-
-    for change in ${SPACK_GERRIT_CHANGE//,/ }; do
-        ssh -p ${GERRIT_PORT} \
-               ${GERRIT_USERNAME}@${GERRIT_HOSTNAME} gerrit query \
-               --current-patch-set ${change} > ${gerrit_query}
-
-        # check that the change corresponds to a spack change and extract
-        # refspec
-        SPACK_GERRIT_REFSPEC="$(awk '
-            $1 ~ "project:" && $2 ~ "spack" { project_found=1 }
-            $1 ~ "ref:" && project_found { print $2 }' "${gerrit_query}" )"
-
-        # break as soon as we have the change for the spack repo
-        if [ -n "${SPACK_GERRIT_REFSPEC}" ]; then
-
-            change_status="$(awk '$1 ~ "status:" { print $2 }' "${gerrit_query}")"
-            # in case we have a stable build, just make sure that the change we
-            # depend on has been merged, if not -> fail early!
-            if [ "${CONTAINER_BUILD_TYPE}" = "stable" ]; then
-                if [ "${change_status}" != "MERGED" ]; then
-                    echo "This change depends on unmerged spack changeset! Aborting.." >&2
-                    rm "${gerrit_query}"
-                    exit 1
-                fi
-            else
-                if [ "${change_status}" = "MERGED" ]; then
-                    echo "This change depends on an already merged spack changeset! Ignoring.." >&2
-                    SPACK_GERRIT_REFSPEC=""
-                fi
-            fi
-
-            # if SPACK_GERRIT_REFSPEC is still set, then we found a valid
-            # changeset to checkout -> break
-            # else -> continue searching
-            #
-            # We want to support two workflows:
-            # * specify one changeset that represents a stack of changes in the
-            #   spack repo to be checked out
-            # * specify several independent spack changesets that are to be
-            #   cherry-picked on top of each other
-            #
-            # Therefore, we check out the first unmerged refspec we encounter
-            # and cherry pick all further changes.
-            if [ -n "${SPACK_GERRIT_REFSPEC}" ]; then
-
-                if [ "${CONTAINER_BUILD_TYPE}" != "stable" ]; then
-                    git fetch ${MY_GERRIT_URL} "${SPACK_GERRIT_REFSPEC}"
-
-                    if [[ "${ref_stable}" == "$(git rev-parse HEAD)" ]]; then
-                        echo "SPACK_GERRIT_REFSPEC was specified for the first"\
-                            "time: ${SPACK_GERRIT_REFSPEC} -> check out" >&2
-
-                        git checkout FETCH_HEAD
-                    else
-                        echo "SPACK_GERRIT_REFSPEC was specified again:"\
-                            "${SPACK_GERRIT_REFSPEC} -> cherry-pick" >&2
-
-                        git cherry-pick FETCH_HEAD
-                    fi
-                else
-                    echo "yashchiki HEAD contains 'Depends-On:' but we are building stable -> ignoring!" >&2
-                fi
-
-                # prevent SPACK_GERRIT_REFSPEC from getting checked out again below
-                SPACK_GERRIT_REFSPEC=""
-            fi
-        fi
-    done
-
-    rm "${gerrit_query}"
-
-    popd
-fi
-
-# if SPACK_GERRIT_REFSPEC was specified on its own (i.e., in bld_gerrit-yashchiki-spack-manual), check it out now!
-if [ "${CONTAINER_BUILD_TYPE}" != "stable" ] && [ -n "${SPACK_GERRIT_REFSPEC:-}" ]; then
-    echo "SPACK_GERRIT_REFSPEC was specified: ${SPACK_GERRIT_REFSPEC} -> checking out"
-    pushd "spack"
-    git fetch  ${MY_GERRIT_URL} "${SPACK_GERRIT_REFSPEC}" && git checkout FETCH_HEAD
-    popd
-fi
-
diff --git a/.ci/deploy_utilities.sh b/.ci/deploy_utilities.sh
index a79f41d0ed6266ad92be90862d2c558e8866cae1..ca71938d0f1b83e66d01fa741b11a97f1ec790ae 100755
--- a/.ci/deploy_utilities.sh
+++ b/.ci/deploy_utilities.sh
@@ -1,6 +1,6 @@
 #!/bin/bash
 
-SOURCE_FOLDER="utils"
+SOURCE_FOLDER="yashchiki/utils"
 
 TARGET_FOLDER="/containers/utils"
 NAME_FILTER=( "(" -name "*.py" -or -name "*.sh" ")" )
diff --git a/.ci/deploy_utility_with_preamble.sh b/.ci/deploy_utility_with_preamble.sh
index 9369e9fc1148c439adb98d713f9bd0ebd07d470b..502bb2c92b39c57ef5a3a7f2a3c37157705100c3 100755
--- a/.ci/deploy_utility_with_preamble.sh
+++ b/.ci/deploy_utility_with_preamble.sh
@@ -16,14 +16,16 @@ echo "#"
 echo "# auto-deployed on $(date --iso) via"
 echo "# https://brainscales-r.kip.uni-heidelberg.de:11443/job/bld_install-yashchiki/"
 echo -n "# from git-commit: "
-git log --no-decorate --oneline -n 1
+(
+cd yashchiki && git log --no-decorate --oneline -n 1
+)
 echo "#"
 echo "# Please submit changes at ssh://brainscales-r.kip.uni-heidelberg.de:29418/yashchiki"
 echo ""
 }
 
 # source and destination are reversed for xargs!
-len_preamble=$(awk -f "$(git rev-parse --show-toplevel)/.ci/find_num_lines_shebang.awk" "${src}")
+len_preamble=$(awk -f "$(cd yashchiki && git rev-parse --show-toplevel)/.ci/find_num_lines_shebang.awk" "${src}")
 head -n "${len_preamble}" "${src}" > "${dst}"
 make_preamble >> "${dst}"
 tail -n +$(( len_preamble + 1 )) "${src}" >> "${dst}"
diff --git a/.ci/dump_meta_info.sh b/.ci/dump_meta_info.sh
index e56368d5913c2a5d23c40fd9a4c5aaecbecc37f1..c41047d227addc42a1fa979e85469f19b6c8c908 100755
--- a/.ci/dump_meta_info.sh
+++ b/.ci/dump_meta_info.sh
@@ -12,7 +12,7 @@ source "${SOURCE_DIR}/commons.sh"
 mkdir -p "${META_DIR_OUTSIDE}"
 
 (
-    cd "${WORKSPACE}"
+    cd "${WORKSPACE}/yashchiki"
     git log > "${META_DIR_OUTSIDE}/yashchiki_git.log"
     if [ "${CONTAINER_BUILD_TYPE}" = "testing" ]; then
         gerrit_get_current_change_commits \
diff --git a/.ci/notify_gerrit.sh b/.ci/notify_gerrit.sh
index f5b73607901a0ddb6dcaec7b21f1d839b5078f77..0b53383e1ce438ef2d58c2ecc4d5ec8fd0a13f0d 100755
--- a/.ci/notify_gerrit.sh
+++ b/.ci/notify_gerrit.sh
@@ -83,6 +83,8 @@ if [ "${CONTAINER_BUILD_TYPE}" = "testing" ]; then
         pushd "${MY_SPACK_FOLDER}" &>/dev/null || exit 1
     fi
 
+    # needs to be in git repo for gerrit_notify_change to work
+    cd ${WORKSPACE}/yashchiki
     for change in "${commits[@]}"; do
         if ! gerrit_notify_change -c "${change}" \
             -v "${verified}" \
diff --git a/.ci/validate_environment.sh b/.ci/validate_environment.sh
index c3e2906d78dbcf92a1b605ec3d7871d27dd72ba0..58a967462e76add1336237ca36a50fee4907cb99 100755
--- a/.ci/validate_environment.sh
+++ b/.ci/validate_environment.sh
@@ -40,11 +40,6 @@ source "${SOURCE_DIR}/commons.sh"
 # `WITH_CACHE_NAME=<name>`. If not, check if there is a saved build cache from a
 # previous build of this changeset and use that as build cache. If the comment
 # contains `WITHOUT_FAILED_CACHE` we do nothing, i.e. we use the default cache.
-#
-# Also we check if the gerrit comment message contains a spack change with
-# which we should build specified via `WITH_SPACK_CHANGE=<change-id>`.
-GERRIT_SPECIFIED_SPACK_CHANGE=""
-GERRIT_SPECIFIED_SPACK_REFSPEC=""
 if [ "${CONTAINER_BUILD_TYPE}" = "testing" ] \
     && [ -n "${GERRIT_EVENT_COMMENT_TEXT:-}" ]; then
 
@@ -81,21 +76,8 @@ if [ "${CONTAINER_BUILD_TYPE}" = "testing" ] \
         export SPACK_VERBOSE=""
     fi
 
-    if grep -q "WITH_SPACK_CHANGE" "${tmpfile_comment}"; then
-        GERRIT_SPECIFIED_SPACK_CHANGE="$(sed -nE \
-            -e "s:.*\<WITH_SPACK_CHANGE=(\S*)\>.*:\1:gp" \
-            "${tmpfile_comment}")"
-
-    elif grep -q "WITH_SPACK_REFSPEC" "${tmpfile_comment}"; then
-        GERRIT_SPECIFIED_SPACK_REFSPEC="$(sed -nE \
-            -e "s:.*\<WITH_SPACK_REFSPEC=(\S*)\>.*:\1:gp" \
-            "${tmpfile_comment}")"
-    fi
-
     rm "${tmpfile_comment}"
 fi
-export GERRIT_SPECIFIED_SPACK_CHANGE
-export GERRIT_SPECIFIED_SPACK_REFSPEC
 
 # store environment for usage within container
 echo "# Jenkins environment set to:" >&2
diff --git a/.ci/visionary_create_recipe.sh b/.ci/visionary_create_recipe.sh
index 02df86d9724f933aabf151b5e09ad35c1c58f99f..8f4d0a0daa41b980a708d97fb6a91a9ce471b9c1 100755
--- a/.ci/visionary_create_recipe.sh
+++ b/.ci/visionary_create_recipe.sh
@@ -46,7 +46,7 @@ From: ${DOCKER_BASE_IMAGE}
     rsync -av "${META_DIR_OUTSIDE}"/* "\${SINGULARITY_ROOTFS}/${META_DIR_INSIDE}"
     # init scripts for user convenience
     mkdir -p "\${SINGULARITY_ROOTFS}/opt/init"
-    rsync -av "${WORKSPACE}"/misc-files/init/*.sh "\${SINGULARITY_ROOTFS}/opt/init"
+    rsync -av "${WORKSPACE}"/yashchiki/misc-files/init/*.sh "\${SINGULARITY_ROOTFS}/opt/init"
 
 %files
     # NOTE: Due to a bug in singularity 2.6 all paths in this section _cannot_
@@ -54,10 +54,10 @@ From: ${DOCKER_BASE_IMAGE}
     # there are, I pray for your poor soul that escaping them works..
     # --obreitwi, 17-02-19 # 23:45:51
     # provide spack command to login shells
-    ${WORKSPACE}/misc-files/setup-spack.sh /etc/profile.d/setup-spack.sh
-    ${WORKSPACE}/misc-files/locale.gen /etc/locale.gen
-    ${WORKSPACE}/misc-files/locale.alias /etc/locale.alias
-    ${WORKSPACE}/misc-files/sudoers /etc/sudoers
+    ${WORKSPACE}/yashchiki/misc-files/setup-spack.sh /etc/profile.d/setup-spack.sh
+    ${WORKSPACE}/yashchiki/misc-files/locale.gen /etc/locale.gen
+    ${WORKSPACE}/yashchiki/misc-files/locale.alias /etc/locale.alias
+    ${WORKSPACE}/yashchiki/misc-files/sudoers /etc/sudoers
     ${JENKINS_ENV_FILE} ${JENKINS_ENV_FILE_INSIDE}
 
 %post
diff --git a/README.md b/README.md
index 61e648cb8a5644fa33bf6b7b04aa6516753d6aa8..d3633afbca51d534ee0a8e4f4d86a6711a9aed34 100644
--- a/README.md
+++ b/README.md
@@ -40,26 +40,14 @@ Use `/home/vis_jenkins/build_caches/<name>` on `conviz` as buildcache instead
 of the default one. Can also be used for failed caches.
 
 
-### `WITH_SPACK_{CHANGE,REFSPEC}`
+### `WITH_DEBUG`
+
+Specifying `WITH_DEBUG` in the triggering comment will enable debug output.
+
+
+## Supported keywords in commit message
 
 Since often times yashchiki and spack changes are tested together but
 have no real dependency on one another, we misuse the `Depends-On`
 mechanism in the commit message to build a container with a specific
 spack and yashchiki changeset.
-
-You can use:
-* `WITH_SPACK_CHANGE=<change-num>` to use the latest patch set of the
-  given spack changeset for the build
-* `WITH_SPACK_REFSPEC=<refspec>` to specify a complete spack refspec
-  that is to be used for this build (i.e.,
-  refs/changes/<change-num[-2:]>/<change-num>/<patch-level>) to have
-  full control over which changeset/patch level to build.
-
-These take priority over commit-specified `Depends-On:` and are mutually
-exclusive with jenkins-specified build parameters since each build gets
-either triggered manually in jenkins or via gerrit.
-
-
-### `WITH_DEBUG`
-
-Specifying `WITH_DEBUG` in the triggering comment will enable debug output.